#!/usr/bin/perl

######################  
# Copyright  2000 Portal Scripts.
# All Rights Reserved.  
#                       
# The original developer of this software module and his/her company, the subsequent
# editors and their companies, have no liability for use of this
# software module or modifications thereof in an implementation.
#                       
# Permission to use, copy, and modify this software and its documentation on
# the server of the customer is hereby granted, provided that the above copyright
# notice, this paragraph and the following two paragraphs appear in all
# copies.               
#                       
# This software program and documentation are copyrighted by Portal Scripts. 
# The software program and documentation are supplied "as is", without any 
# accompanying services. Portal Scripts does not 
# warrant that the operation of the program will be
# uninterrupted or error-free.
#                       
# IN NO EVENT SHALL PORTAL SCRIPTS BE LIABLE TO ANY PARTY FOR
# DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES, INCLUDING
# LOST PROFITS, ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION.
#                       
######################  

use strict;

my $real_path;
if($^O =~ m#win32#i){
	if($ENV{'PATH_TRANSLATED'} ne ""){
		$real_path = $ENV{'PATH_TRANSLATED'};
		$real_path =~ s#\\#/#g;
		$real_path =~ s#[^/]*$##;
		chdir($real_path);
	}
}
else{
	if($ENV{'SCRIPT_FILENAME'} ne ""){
		$real_path = $ENV{'SCRIPT_FILENAME'};
		$real_path =~ s#[^/]*$##;
		chdir($real_path);
	}
}


chdir("..");
require "tools.pm";

my ($help) = spider_url("http://www.portalscripts.com/odp/help.txt");
my %HELP = grep{length} split("<SEPARATOR>", $help);

my %formdata = &Parse_Form;
my %CONFIG = &read_config;

if($CONFIG{'MAX_LOGS'} > 1000){
	$CONFIG{'MAX_LOGS'} = 1000;
}

print "Content-type: text/html\n\n";

if(exists $formdata{'current_admin_password'}){
	if($formdata{'current_admin_password'} eq $CONFIG{'ADMIN_PASSWORD'}){
		delete $formdata{'current_admin_password'};
		delete $formdata{'submit'};
		update_conf(\%formdata);
		print qq!
			Your changes are saved. <a href="admin.cgi?enterance_pass=$formdata{'ADMIN_PASSWORD'}">Click here</a> to continue modifying your configuration.
		!;
	}
	else{
		print "authorization incorrect";
	}
	exit;
}

if(exists $formdata{'enterance_pass'}){
	if($formdata{'enterance_pass'} eq $CONFIG{'ADMIN_PASSWORD'}){

	my $out = "";
	$out .= qq!
		<html>
		<head>
		
			<STYLE TYPE="text/css">
			A.darklink:link	{ text-decoration: none;color: white;};
			A.darklink:visited	{ text-decoration: none;color: white;};
			A.darklink:hover	{ text-decoration: none;color: aqua;};
			A.menulink:link	{ text-decoration: none;color: white;};
			A.menulink:visited	{ text-decoration: none;color: white;};
			A.menulink:hover	{ text-decoration: none;color: white;};
			A:link { text-decoration: underline;color: navy;};
			A:visited { text-decoration: underline;color: navy;};
			A:hover { text-decoration: none;color: navy;};
		
		
		      BODY {
		         font-size: 12pt; 
		         font-family: arial; 
		         }  
		      P {
		         font-size: 12pt; 
		         font-family: arial; 
		         }  
		      TD {
		         font-size: 12pt; 
		         font-family: arial; 
		         }
		      TD.header {
		         font-size: 16pt; 
		         font-family: arial; 
		         color: ffc000;
		         }
		      H1 {
		         font-size: 16pt; 
		         font-family: arial;
		         } 
		      H3 {
		         font-family: arial;
		         } 
		
		  	</STYLE>
		
		
		<TITLE>ODP++</TITLE>
		</head>
		
		<body bgcolor="#FFFFFF">		
		<h2>ODP++ Admin</h2>
		<form method="POST" action="admin.cgi">
		  <table border="1" width="100%">
		    <tr>
		      <td width="33%"><b>Item</b></td>
		      <td width="33%"><b>Value</b></td>
		      <td width="33%"><b>Quick Help</b></td>
		    </tr>
	!;
	
	for my $key (sort keys %CONFIG){
		my $temp = $key;
		$temp =~ s#_# #g;
		$out .= qq!
		    <tr>
		      <td width="33%"><b>$temp</b></td>
		      <td width="33%"><input type="text" name="$key" size="27" value='$CONFIG{$key}'></td>
		      <td width="33%">$HELP{$key}</td>
		    </tr>
		!;
	}
	
	$out .= qq!
		  </table>
		  <p><center><input type="submit" value="Submit" name="submit"></center></p>
		  <input type="hidden" name="current_admin_password" value="$formdata{'enterance_pass'}">
		</form>
		</body>
		</html>
	!;
	
	print $out;
	}
	else{
		print "authorization incorrect";		
	}
	exit;
}


print qq!
	<form method="POST" action="admin.cgi">
	  <p>Password: <input type="text" name="enterance_pass" size="20"><input type="submit" value="Submit" name="B1"></p>
	</form>
!;


sub update_conf {
	my ($formdata) = @_;
	open(LIST, ">system.conf");
	flock(LIST, 2);
	for (keys %$formdata){
		print LIST "$_ == $formdata->{$_}\n";
	}
	flock(LIST, 8);
	close(LIST);
}

